//
//  constants_declaration.h
//  dtbca_public_release
//
//  Created by Dhruv Batra on 5/20/12.
//  Copyright 2012 Dhruv Batra. All rights reserved.
//

//////////////////////////////////////////////////////////////////
// Which algorithms to run
// -2 : MPLP
// -1 : TRW-S
//  0 : star-TBCA
//  1 : comb-TBCA
//  2 : LPDG-based TBCA
//  3 : WTA(10)-based TBCA
extern vector<int> alg_list;

// Convergence criteria
extern int MAXITER;
extern int MAXTIME;
extern double INT_GAP_THRES;
extern double DUAL_IMPROV_THRES;

// Standard Values
extern double default_potts_lambda;

// Precision
extern int MAX_INT; 
extern bool en_round;
#define INF 100000

typedef int Inttype;
typedef int Labeltype;

// Paths
extern string inputpath; 
extern string outputpath;
extern string name;
extern string ext;
extern string mask_filename;

// Energy file type
extern string energytype;

//#define TYPE_POTTS

// Heuristics for improving message-passing convergence
extern bool DILATE;
extern int NUM_ITERATIONS_OF_COMBS;

// Whether or not to save or load messages
extern bool LOAD_MESSAGES;
extern bool SAVE_MESSAGES;
extern bool MODIFY_MASK;
