// Copyright 2009 and onwards
// Author: dtarlow@cs.toronto.edu (Danny Tarlow)
// 7/20/2009
//
// Definitions and typedefs

#ifndef CYBORG_DEFINITIONS__
#define CYBORG_DEFINITIONS__


#include <iostream>
#include <string>
#include <ext/hash_map>

using namespace std;

#define DEFAULT_DAMPING .5
#define BIG_DOUBLE 1000000000.0
#define FORCE_ASSIGNMENT BIG_DOUBLE

#define HORIZONTAL true
#define VERTICAL false

//static string BASE_DATA_DIR = "/u/dtarlow/workspace/data/";
static string BASE_DATA_DIR = "/Users/dt/workspace/data/";
static string DATA_DIR = BASE_DATA_DIR + "pushmeet/";
static string OCCLUSION_DIR = BASE_DATA_DIR + "occlusion/";
static string SIMILARITY_DATA_DIR = BASE_DATA_DIR + "exemplar_model/";


// Purely for convenience, mostly for use with stl data structures that
// use unsigned ints for size_t.
typedef unsigned int uint;

// How to represent probabilities.  (Not currently used)
typedef double prob_t;

// Yech, why is hash_set in such a weird namespace?
//typedef __gnu_cxx::hash_set<uint> uint_hash_set;
typedef __gnu_cxx::hash_map<int, int> int_map;

typedef __gnu_cxx::hash_map<int, double> int_double_map;


// How to represent variables and values at the most basic level
typedef int variable_index;

typedef int measure_variable_index;

typedef int value_index;

typedef uint cardinality;

enum message_direction_t {TO_VARIABLE, TO_FACTOR};

enum message_schedule_t {
  SYNCHRONOUS,
  ASYNCHRONOUS, 
  RESIDUAL,
  MPLP,
  ASYNCHRONOUS_FACTOR,
  TRW,
  ICM,
  DD,
  SIMULATED_ANNEALING,
  BRUTE};

enum search_type_t {SUM_COST, MAX_COST, SECOND_MAX_COST};

enum direction_t {LEFT_TO_RIGHT, TOP_TO_BOTTOM, TL_BR, TR_BL};

enum problem_t {SEGMENTATION, MULTI_SEGMENTATION, IMAGE_LABELING,
		MATCHING, CLUSTERING, RANKING, OTHER};

enum factor_class_t {
  DEFAULT,
  HARD_1_OF_N,
  HARD_B_OF_N,
  SINGLETON_NN, 
  SINGLETON_GIST, 
  PAIRWISE_CONST,
  PAIRWISE_CONTRAST,
  GLOBAL_SIZES,
  TRUE_SIZE,
  MARGIN_SCALING,
  SLACK_SCALING
};

#endif  // CYBORG_DEFINITIONS__
