//
//  type_potts.h
//  dtbca_public_release
//
//  Created by Dhruv Batra on 8/25/11.
//  Copyright 2011 Dhruv Batra. All rights reserved.
//
//  Inspired by Vladimir Kolmogorov's typePotts.h in TRW-S

#ifndef __TYPE_POTTS_H__
#define __TYPE_POTTS_H__

#include <iostream>

#include "utils.h"
#include "constants_declaration.h"
#include "mrf_energy.h"

// Class that holds Data (graph, node and edge potentials) for a Potts-MRF
// where all nodes have the same no. of labels
class TypePotts : public PairwiseEnergy
{
public:
    /////////////////////////////////////////////////////////
    // Data
    Labeltype nlabels;
    
    /////////////////////////////////////////////////////////
    // Functions

    // Constructor
    TypePotts():
    nlabels(0)
    { }
    
    void LoadEnergyFromFile(char *fname);
    void RoundEnergy();

};


#endif